/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.basislib.kalender.ereignisSystemKalender;

import java.util.List;

import org.eclipse.swt.widgets.Shell;

import de.bsvrz.buv.rw.basislib.kalender.IEintragBereich;
import de.bsvrz.buv.rw.basislib.kalender.KalenderBereichDialog;

/**
 * Dialog zur Auswahl von Ereignissen aus dem Ereignis-/Systemkalender.
 * 
 * @author HofmannJ
 * @deprecated ersetzt durch {@link KalenderBereichDialog}
 */
@Deprecated
public class DialogEreignisSystemkalenderUebernahme extends
		KalenderBereichDialog {

	/**
	 * Konstruktor dieses Dialoges.
	 * 
	 * @param parent
	 *            {@link Shell}.
	 */
	public DialogEreignisSystemkalenderUebernahme(final Shell parent) {
		super(parent);
	}

	public DialogEreignisSystemkalenderUebernahme(
			final Shell parent,
			final de.bsvrz.buv.rw.basislib.kalender.KalenderBereichDialog.Quelle initialeQuelle) {
		super(parent, initialeQuelle);
	}

	/**
	 * ffnet den Dialog. Es werden Ereignis- und Systemkalendereintrge
	 * bercksichtigt.
	 * 
	 * @return Liste der ausgewhlten Eintrgen.
	 */
	public List<IEintragBereich> oeffnen() {
		setInitialeQuelle(de.bsvrz.buv.rw.basislib.kalender.KalenderBereichDialog.Quelle.systemkalender);
		open();
		return getSelektierteBereiche();
	}

	/**
	 * ffnet den Dialog. Es werden Eintrge entsprechend der angegebenen
	 * {@link Quelle}.
	 * 
	 * @param neueQuelle
	 *            <code>Quelle.ereigniskalender</code> oder
	 *            <code>Quelle.systemkalender</code>.
	 * @return Liste der ausgewhlten Eintrge.
	 */
	public List<IEintragBereich> oeffnen(final Quelle neueQuelle) {
		if (neueQuelle == Quelle.systemkalender) {
			setInitialeQuelle(de.bsvrz.buv.rw.basislib.kalender.KalenderBereichDialog.Quelle.systemkalender);
		} else {
			setInitialeQuelle(de.bsvrz.buv.rw.basislib.kalender.KalenderBereichDialog.Quelle.ereigniskalender);
		}
		open();
		return getSelektierteBereiche();
	}

	/**
	 * Enumerator zur Auswahl der Quelle (Ereignis- oder Systemkalender).
	 * 
	 * @author HofmannJ
	 * 
	 */
	public enum Quelle {
		ereigniskalender("Ereigniskalender",
				"Eintrge aus dem Ereigniskalender"), systemkalender(
				"Systemkalender", "Eintrge aus dem Systemkalender");

		/**
		 * Bezeichnung des Eintrags.
		 */
		private String bezeichnung;

		/**
		 * Beschreibung des Eintrags.
		 */
		private String beschreibung;

		/**
		 * Konstruktor. Setzt Bezeichnung und Beschreibung des Eintrags
		 * 
		 * @param bezeichnung
		 *            Bezeichnung des Eintrags
		 * @param beschreibung
		 *            Beschreibung des Eintrags
		 */
		private Quelle(final String bezeichnung, final String beschreibung) {
			this.bezeichnung = bezeichnung;
			this.beschreibung = beschreibung;
		}

		/**
		 * Liefert die Bezeichnung.
		 * 
		 * @return Bezeichnung
		 */
		public String getBezeichnung() {
			return bezeichnung;
		}

		/**
		 * Liefert die Beschreibung.
		 * 
		 * @return Beschreibung
		 */
		public String getBeschreibung() {
			return beschreibung;
		}

		@Override
		public String toString() {
			final String re = bezeichnung + " (" + beschreibung + ")";
			return re;
		}
	}
}
