/*
 * This file is part of Rahmenwerk 2.0.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Copyright (c) 2013 BitCtrl Systems GmbH.
 * 
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weissenfelser Strae 67
 * 04229 Leipzig
 * Phone: +49-341-49067-0
 * Fax:   +49-341-49067-15
 * mailto: support@bitctrl.de
 * 
 * Partly inspired by the original Rahmenwerk created by Dambach Werke GmbH.  
 */

package de.bsvrz.buv.rw.basislib.legende;

/**
 * Schnittstelle fr ein Element, das eine Aktualisierungszeit liefern kann.
 * 
 * Im Legendenfenster wird die Aktualisierungszeit eines WorkbenchParts, der
 * dieses Interface implementiert bzw, der auf dieses Interface adaptierbar ist,
 * zyklisch abgefragt und im {@link LegendeWindow} visualisiert.
 * 
 * @author BitCtrl Systems GmbH, Uwe Peuker
 * @version $Id: IUpdateTimeProvider.java 45393 2013-08-07 21:32:57Z peuker $
 * 
 */
public interface IUpdateTimeProvider {

	/**
	 * liefert die letzte Aktualisierungszeit die dem Provider bekannt ist.
	 * 
	 * @return die Zeit in Millisekunden
	 */
	long getLastUpdateTime();
}
