/*
 * This file is part of Rahmenwerk 2.0.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Copyright (c) 2013 BitCtrl Systems GmbH.
 * 
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weissenfelser Strae 67
 * 04229 Leipzig
 * Phone: +49-341-49067-0
 * Fax:   +49-341-49067-15
 * mailto: support@bitctrl.de
 * 
 * Partly inspired by the original Rahmenwerk created by Dambach Werke GmbH.  
 */

package de.bsvrz.buv.rw.basislib.menu;

import java.util.Map;

import org.eclipse.jface.action.ContributionItem;

/**
 * Abstrakte Implementierung der Schnittstelle {@link RwMenuControl}.
 * 
 * Es werden keine Parameter ausgewertet und das Element kann in keinem der drei
 * Zielbereiche (Men, Symbolleiste, Statusleiste) verwednet werden. Die
 * entsprechenden Funktionen zur Freigabe eines Anwendungsbereiches und zur
 * Verarbeitung der Parameter mssen von der Subklasse berladen werden.
 * 
 * @author BitCtrl Systems GmbH, Uwe Peuker
 * @version $Id: AbstractRwMenuControl.java 45393 2013-08-07 21:32:57Z peuker $
 */
public abstract class AbstractRwMenuControl extends ContributionItem implements
		RwMenuControl {

	@Override
	public void setParameter(final Map<String, String> parameter) {
		// Parameter werden nicht ausgewertet
	}

	@Override
	public boolean useInMenue() {
		return false;
	}

	@Override
	public boolean useInToolbar() {
		return false;
	}

	@Override
	public boolean useInStatusLine() {
		return false;
	}
}
