/*
 * This file is part of Rahmenwerk 2.0.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Copyright (c) 2013 BitCtrl Systems GmbH.
 * 
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weissenfelser Strae 67
 * 04229 Leipzig
 * Phone: +49-341-49067-0
 * Fax:   +49-341-49067-15
 * mailto: support@bitctrl.de
 * 
 * Partly inspired by the original Rahmenwerk created by Dambach Werke GmbH.
 */

package de.bsvrz.buv.rw.rw.berechtigungen;

import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;

/**
 * Aktivator des Plug-ins zur Bereitstellung des Services "Berechtigungen".
 * 
 * @author BitCtrl Systems GmbH, Uwe Peuker
 * @version $Id: RwBerechtigungen.java 48338 2014-01-24 10:06:42Z peuker $
 */
public class RwBerechtigungen extends AbstractUIPlugin {

	/** ID des Plug-ins. */
	public static final String PLUGIN_ID = "de.bsvrz.buv.rw.rw.berechtigungen";

	private static RwBerechtigungen plugin;

	@Override
	public void start(final BundleContext context) throws Exception {
		super.start(context);
		RwBerechtigungen.plugin = this;

	}

	@Override
	public void stop(final BundleContext context) throws Exception {
		RwBerechtigungen.plugin = null;
		super.stop(context);
	}

	/**
	 * liefert die globale Instanz des Plug-ins, nachdem es aktiviert wurde.
	 * Anderenfalls wird <code>null</code> geliefert.
	 * 
	 * @return die Instanz oder <code>null</code>
	 */
	public static RwBerechtigungen getDefault() {
		return RwBerechtigungen.plugin;
	}
}
