/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.rw.kommandozeilenparameter;

import de.bsvrz.buv.rw.basislib.Rahmenwerk;
import de.bsvrz.sys.funclib.commandLineArgs.ArgumentList.Argument;

/**
 * Kapselt einen Kommandozeilenparameter.
 * 
 * @author HofmannJ
 * @deprecated die Parameter werden vom {@link Rahmenwerk} als {@link Argument}
 *             bereitgestellt
 */
@Deprecated
public class KmdParameter {
	/**
	 * Schlssel des Parameters.
	 */
	private final String schluessel;

	/**
	 * Wert des Parameters.
	 */
	private final String wert;

	/**
	 * Konstruktor. bernimmt als Parameter Schlssel und Wert des
	 * Kommandozeilenargumentes.
	 * 
	 * @param schluessel
	 *            Schlssel
	 * @param wert
	 *            Wert
	 */
	public KmdParameter(final String schluessel, final String wert) {
		this.schluessel = schluessel;
		this.wert = wert;
	}

	/**
	 * Liefert den Schlssel des Parameters.
	 * 
	 * @return Schlssel des Parameters
	 */
	public String getSchluessel() {
		return schluessel;
	}

	/**
	 * Liefert den Wert des Parameters.
	 * 
	 * @return Wert des Parameters
	 */
	public String getWert() {
		return wert;
	}

	@Override
	public String toString() {
		final String re = "Schlssel: " + schluessel + " Wert: " + wert;
		return re;
	}
}
