/*
 * This file is part of Rahmenwerk 2.0.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Copyright (c) 2013 BitCtrl Systems GmbH.
 * 
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weissenfelser Strae 67
 * 04229 Leipzig
 * Phone: +49-341-49067-0
 * Fax:   +49-341-49067-15
 * mailto: support@bitctrl.de
 * 
 * Partly inspired by the original Rahmenwerk created by Dambach Werke GmbH.
 */

package de.bsvrz.buv.rw.rw.menu;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * Definition eines Separators in einer Mendefinition.
 * 
 * @author BitCtrl Systems GmbH, Uwe Peuker
 * @version $Id: MenueSeparator.java 45420 2013-08-09 12:12:12Z peuker $
 */
public class MenueSeparator extends AbstractMenueElement {

	private Menue menue;

	@Override
	public Menue getMenue() {
		return menue;
	}

	@Override
	public void setMenue(final Menue menue) {
		this.menue = menue;
	}

	@Override
	protected void addXmlNode(final Document document, final Element root) {
		final Element element = document
				.createElement(MenuXmlHandler.TAG_SEPARATOR);
		root.appendChild(element);
	}

	@Override
	public MenueElement createDeepCopy() {
		return new MenueSeparator();
	}
}
