/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */
package de.bsvrz.buv.rw.rw.offlinekonfiguration;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;

public class DarstellungComposite extends Composite {

	public DarstellungComposite(final Composite parent, final int style) {
		super(parent, style);
		initialize();
	}

	private void initialize() {
		createGroupGruppe();
		createCompositeKontrolle();
		setSize(new Point(300, 200));
		setLayout(new GridLayout());
	}

	/**
	 * This method initializes groupGruppe.
	 * 
	 */
	private void createGroupGruppe() {
		final GridData gridData = new GridData();
		gridData.horizontalAlignment = GridData.FILL;
		gridData.grabExcessHorizontalSpace = true;
		gridData.verticalAlignment = GridData.CENTER;
		final Group groupGruppe = new Group(this, SWT.NONE);
		groupGruppe.setLayout(new GridLayout());
		groupGruppe.setLayoutData(gridData);
		groupGruppe.setText("Gruppe");
	}

	/**
	 * This method initializes compositeKontrolle.
	 * 
	 */
	private void createCompositeKontrolle() {
		final GridData gridData3 = new GridData();
		gridData3.horizontalAlignment = GridData.END;
		gridData3.verticalAlignment = GridData.CENTER;
		final GridData gridData2 = new GridData();
		gridData2.horizontalAlignment = GridData.FILL;
		gridData2.verticalAlignment = GridData.CENTER;
		final GridData gridData1 = new GridData();
		gridData1.horizontalAlignment = GridData.FILL;
		gridData1.verticalAlignment = GridData.CENTER;
		final GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 2;
		gridLayout.makeColumnsEqualWidth = true;
		final Composite compositeKontrolle = new Composite(this, SWT.NONE);
		compositeKontrolle.setLayout(gridLayout);
		compositeKontrolle.setLayoutData(gridData3);
		final Button buttonLinks = new Button(compositeKontrolle, SWT.NONE);
		buttonLinks.setText("bernehmen");
		buttonLinks.setLayoutData(gridData1);
		final Button buttonAbbrechen = new Button(compositeKontrolle, SWT.NONE);
		buttonAbbrechen.setText("Abbrechen");
		buttonAbbrechen.setLayoutData(gridData2);
	}

}
