/*
 * This file is part of Rahmenwerk 2.0.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Copyright (c) 2013 BitCtrl Systems GmbH.
 * 
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weissenfelser Strae 67
 * 04229 Leipzig
 * Phone: +49-341-49067-0
 * Fax:   +49-341-49067-15
 * mailto: support@bitctrl.de
 * 
 */

package de.bsvrz.buv.rw.rw.perspective;

import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;

/**
 * Standardperspektive, als Rckfallebene, wenn keine andere vorgegeben wurde.
 * 
 * @author BitCtrl Systems GmbH, Uwe Peuker
 * @version $Id: DefaultPerspective.java 47179 2013-11-18 08:03:03Z peuker $
 */
public class DefaultPerspective implements IPerspectiveFactory {

	/** die ID der Perspektive. */
	public static final String PERSPECTIVE_ID = "de.bsvrz.buv.rw.rw.perspective.default";

	@Override
	public void createInitialLayout(final IPageLayout layout) {
		/*
		 * es muss mindestens ein View eingebaut werden oder die EditorArea ist
		 * sichtbar.
		 */
		layout.setEditorAreaVisible(false);
		layout.addView(RwInfoView.VIEW_ID, IPageLayout.TOP, 0.9f,
				layout.getEditorArea());
	}
}
