/*
 * This file is part of Rahmenwerk 2.0.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Copyright (c) 2013 BitCtrl Systems GmbH.
 * 
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weissenfelser Strae 67
 * 04229 Leipzig
 * Phone: +49-341-49067-0
 * Fax:   +49-341-49067-15
 * mailto: support@bitctrl.de
 * 
 * Partly inspired by the original Rahmenwerk created by Dambach Werke GmbH.
 *   
 **************************************************************************************
 *
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */

package de.bsvrz.buv.rw.rw.printing;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Iterator;
import java.util.LinkedList;

import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.nebula.paperclips.core.LinePrint;
import org.eclipse.nebula.paperclips.core.PaperClips;
import org.eclipse.nebula.paperclips.core.Print;
import org.eclipse.nebula.paperclips.core.PrintJob;
import org.eclipse.nebula.paperclips.core.grid.DefaultGridLook;
import org.eclipse.nebula.paperclips.core.grid.GridPrint;
import org.eclipse.nebula.paperclips.core.page.PageDecoration;
import org.eclipse.nebula.paperclips.core.page.PageNumber;
import org.eclipse.nebula.paperclips.core.page.PageNumberPageDecoration;
import org.eclipse.nebula.paperclips.core.page.PagePrint;
import org.eclipse.nebula.paperclips.core.text.TextPrint;
import org.eclipse.nebula.paperclips.widgets.PrintPreview;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.printing.PrintDialog;
import org.eclipse.swt.printing.PrinterData;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Spinner;

import de.bsvrz.buv.rw.rw.RahmenwerkActivator;
import de.bsvrz.buv.rw.rw.preferences.DefsSeiteneinstellungen;

/**
 * Dialog zur Anzeige eine Druckvorschau.
 * 
 * TODO richtigen Dialog implementieren!
 * 
 * @author BitCtrl Systems GmbH, Uwe Peuker
 * @version $Id: DruckvorschauDialog.java 49072 2014-03-05 15:11:22Z hoesel $
 */
public class DruckvorschauDialog extends Dialog {

	private final Display display;

	private PrintJob printJob;

	private Shell shell;

	private Button schaltflaecheVorhergehendeSeite;

	private Label labelSeitenNummer;

	private Button schaltflaecheNachfolgendeSeite;

	private ScrolledComposite verschiebbaresComposite;

	private PrintPreview druckVorschau;

	private double[] verschiebePosition;

	/**
	 * Konstruktor. bernimmt eine Eltern-{@link Shell} als Parameter.
	 * 
	 * @param parent
	 *            Eltern-{@link Shell}
	 */
	public DruckvorschauDialog(final Shell parent) {
		super(parent, 0);

		this.display = Display.getDefault();
	}

	/**
	 * ffnet den Druckvorschaudialog.
	 * 
	 * @param page
	 *            Zu druckende Seite.
	 * @param druckauftrag
	 *            Titel des Druckauftrags.
	 * @return Liefert <code>true</code>, wenn die Seite gedruckt wurde, sonst
	 *         <code>false</code>.
	 */
	public boolean oeffne(final PagePrint page, final String druckauftrag) {
		if (page != null) {
			final PagePrint erweitertePage = erweiterePage(page, druckauftrag);

			printJob = new PrintJob(druckauftrag, erweitertePage)
					.setMargins(72);

		}

		erzeugeShell();

		shell.open();

		final Display parentDisplay = getParent().getDisplay();
		while (!shell.isDisposed()) {
			if (!parentDisplay.readAndDispatch()) {
				parentDisplay.sleep();
			}
		}

		// FIXME Returnwert korrigieren - Dialog implementieren
		return true;
	}

	private Shell erzeugeShell() {

		shell = new Shell(getParent(), SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL
				| SWT.RESIZE);
		shell.setText("Druckvorschau");
		shell.setBounds(100, 100, 800, 600);
		shell.setLayout(new GridLayout(1, false));

		erzeugeSchaltflaechenBereich(shell).setLayoutData(
				new GridData(SWT.FILL, SWT.FILL, true, false));
		erzeugeVerschiebbareVorschau(shell).setLayoutData(
				new GridData(SWT.FILL, SWT.FILL, true, true));

		druckVorschau.setLazyPageLayout(false);
		display.timerExec(10, new Runnable() {
			@Override
			public void run() {
				druckVorschau.setPrintJob(printJob);
				aktualisiereVorschauGroesse();
				aktualisiereSeitenNummer();
			}
		});

		shell.setVisible(true);

		return shell;
	}

	private Control erzeugeSchaltflaechenBereich(final Composite parent) {
		final Composite composite = new Composite(parent, SWT.NONE);

		final GridLayout layout = new GridLayout(16, false);
		layout.marginWidth = 0;
		layout.marginHeight = 0;
		composite.setLayout(layout);

		schaltflaecheVorhergehendeSeite = erzeugeTextSchaltflaeche(composite,
				"<-", "Schaltet zur vorhergehenden Seite um", new Listener() {

					@Override
					public void handleEvent(final Event event) {
						setVorschauSeitenIndex(druckVorschau.getPageIndex()
								- (druckVorschau.getHorizontalPageCount() * druckVorschau
										.getVerticalPageCount()));

					}
				});

		labelSeitenNummer = new Label(composite, SWT.NONE);
		schaltflaecheNachfolgendeSeite = erzeugeTextSchaltflaeche(composite,
				"->", "Schaltet auf die nachfolgende Seite um", new Listener() {
					@Override
					public void handleEvent(final Event event) {
						aktionSeiteVor();
					}
				});

		erzeugeTextSchaltflaeche(composite, "Horiz. fllen",
				"Fllt die Darstellung horizontal", new Listener() {
					@Override
					public void handleEvent(final Event event) {
						druckVorschau.setFitHorizontal(true);
						druckVorschau.setFitVertical(false);
						sichereVerschiebePosition();
						aktualisiereVorschauGroesse();
						wiederherstellenVerschiebePosition();
					}
				});

		erzeugeTextSchaltflaeche(composite, "Vert. fllen",
				"Fllt die Darstellung vertikal", new Listener() {
					@Override
					public void handleEvent(final Event event) {
						druckVorschau.setFitVertical(true);
						druckVorschau.setFitHorizontal(false);
						sichereVerschiebePosition();
						aktualisiereVorschauGroesse();
						wiederherstellenVerschiebePosition();
					}
				});

		erzeugeTextSchaltflaeche(composite, "Opt. fllen",
				"Fllt die Darstellung optimal", new Listener() {
					@Override
					public void handleEvent(final Event event) {
						druckVorschau.setFitVertical(true);
						druckVorschau.setFitHorizontal(true);
						sichereVerschiebePosition();
						aktualisiereVorschauGroesse();
						wiederherstellenVerschiebePosition();
					}
				});

		erzeugeTextSchaltflaeche(composite, "+", "Hinein zoomen",
				new Listener() {
					@Override
					public void handleEvent(final Event event) {
						setVorschauSkala((float) (druckVorschau
								.getAbsoluteScale() * 1.1));
					}
				});

		erzeugeTextSchaltflaeche(composite, "-", "Heraus zoomen",
				new Listener() {
					@Override
					public void handleEvent(final Event event) {
						setVorschauSkala((float) (druckVorschau
								.getAbsoluteScale() / 1.1));
					}
				});

		erzeugeTextSchaltflaeche(composite, "1:1", "An Skalierung heranzoomen",
				new Listener() {
					@Override
					public void handleEvent(final Event event) {
						setVorschauSkala(1);
					}
				});

		erzeugeTextSchaltflaeche(composite, "Hoch", "Hochformat",
				new Listener() {
					@Override
					public void handleEvent(final Event event) {
						printJob.setOrientation(PaperClips.ORIENTATION_PORTRAIT);
						druckVorschau.setPrintJob(printJob);

						loescheVerschiebePosition();
						aktualisiereVorschauGroesse();
						aktualisiereSeitenNummer();
					}
				});

		erzeugeTextSchaltflaeche(composite, "Quer", "Querformat",
				new Listener() {
					@Override
					public void handleEvent(final Event event) {
						printJob.setOrientation(PaperClips.ORIENTATION_LANDSCAPE);
						druckVorschau.setPrintJob(printJob);

						loescheVerschiebePosition();
						aktualisiereVorschauGroesse();
						aktualisiereSeitenNummer();
					}
				});

		erzeugeGrafischeSchaltflaeche(composite, "icons/etool16/print.gif",
				"Drucken", new Listener() {
					@Override
					public void handleEvent(final Event event) {
						final PrintDialog dialog = new PrintDialog(shell,
								SWT.NONE);
						final PrinterData printerData = dialog.open();
						if (printerData != null) {
							PaperClips.print(printJob, printerData);
							druckVorschau.setPrinterData(printerData);
						}
					}
				});

		erzeugeLabel(composite, "Horz. Seiten:");
		erzeugeSeitenzaehlerSpinner(composite, new Listener() {
			@Override
			public void handleEvent(final Event event) {
				druckVorschau.setHorizontalPageCount(((Spinner) event.widget)
						.getSelection());
				loescheVerschiebePosition();
				aktualisiereVorschauGroesse();
				aktualisiereSeitenNummer();
			}
		});

		erzeugeLabel(composite, "Vert. Seiten:");
		erzeugeSeitenzaehlerSpinner(composite, new Listener() {
			@Override
			public void handleEvent(final Event event) {
				druckVorschau.setVerticalPageCount(((Spinner) event.widget)
						.getSelection());
				loescheVerschiebePosition();
				aktualisiereVorschauGroesse();
				aktualisiereSeitenNummer();
			}
		});

		return composite;
	}

	private void aktionSeiteVor() {
		setVorschauSeitenIndex(druckVorschau.getPageIndex()
				+ (druckVorschau.getHorizontalPageCount() * druckVorschau
						.getVerticalPageCount()));
	}

	private Control erzeugeVerschiebbareVorschau(final Composite parent) {
		verschiebbaresComposite = new ScrolledComposite(parent, SWT.BORDER
				| SWT.H_SCROLL | SWT.V_SCROLL);
		verschiebbaresComposite.setExpandHorizontal(true);
		verschiebbaresComposite.setExpandVertical(true);

		druckVorschau = new PrintPreview(verschiebbaresComposite, SWT.NONE);
		verschiebbaresComposite.setContent(druckVorschau);

		verschiebbaresComposite.addListener(SWT.Resize, new Listener() {
			@Override
			public void handleEvent(final Event event) {
				final Rectangle bounds = verschiebbaresComposite
						.getClientArea();

				verschiebbaresComposite.getHorizontalBar().setPageIncrement(
						(bounds.width * 2) / 3);
				verschiebbaresComposite.getVerticalBar().setPageIncrement(
						(bounds.height * 2) / 3);

				if (druckVorschau.isFitHorizontal()
						^ druckVorschau.isFitVertical()) {
					sichereVerschiebePosition();
					aktualisiereVorschauGroesse();
					wiederherstellenVerschiebePosition();
				}
			}
		});

		druckVorschau.setFitVertical(true);
		druckVorschau.setFitHorizontal(true);

		final Listener dragListener = new Listener() {
			private final Point dpi = display.getDPI();

			private boolean scrollable;

			private boolean dragging;

			private Point dragStartScrollOrigin;

			private Point dragStartMouseAnchor;

			@Override
			public void handleEvent(final Event event) {
				final Point size = druckVorschau.getSize();
				final Rectangle bounds = verschiebbaresComposite
						.getClientArea();
				switch (event.type) {
				case SWT.Resize:
					loescheVerschiebePosition();
					scrollable = (size.x > bounds.width)
							|| (size.y > bounds.height);
					if (!scrollable && dragging) {
						endDragging();
					}
					break;
				case SWT.MouseDown:
					loescheVerschiebePosition();
					if (scrollable && (event.button == 1)) {
						beginDragging(event);
					}
					break;
				case SWT.MouseMove:
					if (dragging) {
						loescheVerschiebePosition();
						final Point point = druckVorschau.toDisplay(event.x,
								event.y);
						verschiebbaresComposite
								.setOrigin(
										(dragStartScrollOrigin.x + dragStartMouseAnchor.x)
												- point.x,
										(dragStartScrollOrigin.y + dragStartMouseAnchor.y)
												- point.y);
					}
					break;
				case SWT.MouseUp:
					loescheVerschiebePosition();
					if (dragging) {
						endDragging();
					}
					break;
				case SWT.MouseEnter:
					display.addFilter(SWT.MouseWheel, this);
					break;
				case SWT.MouseWheel:
					if (event.count != 0) {
						if (scrollable
								&& !dragging
								&& ((event.stateMask == SWT.NONE) || (event.stateMask == SWT.SHIFT))) {
							loescheVerschiebePosition();
							final Point origin = verschiebbaresComposite
									.getOrigin();
							final int direction = event.count > 0 ? -1 : 1;
							// Prefer vertical scrolling unless user is pressing
							// Shift
							if ((size.y > bounds.height)
									&& (event.stateMask == SWT.NONE)) {
								origin.y += direction
										* Math.min(dpi.y, bounds.height / 4);
							} else if (size.x > bounds.width) {
								origin.x += direction
										* Math.min(dpi.x, bounds.width / 4);
							}
							verschiebbaresComposite.setOrigin(origin);
							event.doit = false;
						} else if (event.stateMask == SWT.CTRL) {
							// Ctrl+MouseWheel -> zoom
							final float scale = druckVorschau
									.getAbsoluteScale();
							if (event.count > 0) {
								setVorschauSkala((float) (scale / 1.1));
							} else {
								setVorschauSkala((float) (scale * 1.1));
							}
						}
					}
					break;
				case SWT.MouseExit:
					display.removeFilter(SWT.MouseWheel, this);
					break;
				default:
					break;
				}
			}

			private void beginDragging(final Event event) {
				dragStartScrollOrigin = verschiebbaresComposite.getOrigin();
				dragStartMouseAnchor = druckVorschau
						.toDisplay(event.x, event.y);
				dragging = true;
			}

			private void endDragging() {
				dragging = false;
				dragStartMouseAnchor = null;
				dragStartScrollOrigin = null;
			}
		};

		verschiebbaresComposite.addListener(SWT.Resize, dragListener);
		druckVorschau.addListener(SWT.MouseDown, dragListener);
		druckVorschau.addListener(SWT.MouseMove, dragListener);
		druckVorschau.addListener(SWT.MouseUp, dragListener);

		// These are for mouse wheel handling
		druckVorschau.addListener(SWT.MouseEnter, dragListener);
		druckVorschau.addListener(SWT.MouseExit, dragListener);

		return verschiebbaresComposite;
	}

	private Button erzeugeGrafischeSchaltflaeche(final Composite parent,
			final String imageFilename, final String toolTipText,
			final Listener selectionListener) {
		final Button button = erzeugeSchaltflaeche(parent, toolTipText,
				selectionListener);
		button.setImage(RahmenwerkActivator.getDefault()
				.getImage(imageFilename));
		return button;
	}

	private Button erzeugeTextSchaltflaeche(final Composite parent,
			final String text, final String toolTipText,
			final Listener selectionListener) {
		final Button button = erzeugeSchaltflaeche(parent, toolTipText,
				selectionListener);
		button.setText(text);
		return button;
	}

	private Button erzeugeSchaltflaeche(final Composite parent,
			final String toolTipText, final Listener selectionListener) {
		final Button button = new Button(parent, SWT.PUSH);
		button.setToolTipText(toolTipText);
		button.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false));
		button.addListener(SWT.Selection, selectionListener);
		return button;
	}

	private Spinner erzeugeSeitenzaehlerSpinner(final Composite parent,
			final Listener selectionListener) {
		final Spinner spinner = new Spinner(parent, SWT.BORDER);
		spinner.setMinimum(1);
		spinner.setMaximum(99);
		spinner.addListener(SWT.Selection, selectionListener);
		return spinner;
	}

	private void erzeugeLabel(final Composite parent, final String text) {
		new Label(parent, SWT.NONE).setText(text);
	}

	private void aktualisiereSeitenNummer() {
		final int pageIndex = druckVorschau.getPageIndex();
		final int pageCount = druckVorschau.getPageCount();
		final int visiblePages = druckVorschau.getHorizontalPageCount()
				* druckVorschau.getVerticalPageCount();
		final boolean layoutComplete = druckVorschau.isPageLayoutComplete();
		String text = (visiblePages > 1 ? "Seiten " + (pageIndex + 1) + "-"
				+ Math.min(pageCount, pageIndex + visiblePages) : "Seite "
				+ (pageIndex + 1));
		if (layoutComplete) {
			text += " von " + pageCount;
		}
		labelSeitenNummer.setText(text);
		schaltflaecheVorhergehendeSeite.setEnabled(pageIndex > 0);
		schaltflaecheNachfolgendeSeite
				.setEnabled((pageIndex < (pageCount - visiblePages))
						|| !layoutComplete);
		shell.layout(new Control[] { labelSeitenNummer });
	}

	private void sichereVerschiebePosition() {
		final Point size = druckVorschau.getSize();
		if ((size.x == 0) || (size.y == 0)) {
			loescheVerschiebePosition();
		} else if (verschiebePosition == null) {
			final Point origin = verschiebbaresComposite.getOrigin();
			verschiebePosition = new double[] {
					(double) origin.x / (double) size.x,
					(double) origin.y / (double) size.y };
		}
	}

	private void loescheVerschiebePosition() {
		verschiebePosition = null;
	}

	private void wiederherstellenVerschiebePosition() {
		if (verschiebePosition != null) {
			final Point size = druckVorschau.getSize();
			verschiebbaresComposite.setOrigin(
					(int) Math.round(verschiebePosition[0] * size.x),
					(int) Math.round(verschiebePosition[1] * size.y));
		}
	}

	private void aktualisiereVorschauGroesse() {
		Point minSize;
		final Rectangle bounds = verschiebbaresComposite.getClientArea();
		if (druckVorschau.isFitHorizontal()) {
			if (druckVorschau.isFitVertical()) {
				// Best fit
				minSize = new Point(0, 0);
			} else {
				// Fit to width
				minSize = new Point(0, druckVorschau.computeSize(bounds.width,
						SWT.DEFAULT).y);
			}
		} else {
			if (druckVorschau.isFitVertical()) {
				// Fit to height
				minSize = new Point(druckVorschau.computeSize(SWT.DEFAULT,
						bounds.height).x, 0);
			} else {
				// Custom scale
				minSize = druckVorschau.computeSize(SWT.DEFAULT, SWT.DEFAULT);
			}
		}
		verschiebbaresComposite.setMinSize(minSize);
	}

	private void setVorschauSkala(final float scale) {
		druckVorschau.setFitVertical(false);
		druckVorschau.setFitHorizontal(false);
		druckVorschau.setScale(scale);
		sichereVerschiebePosition();
		aktualisiereVorschauGroesse();
		wiederherstellenVerschiebePosition();
	}

	private void setVorschauSeitenIndex(final int pageIndex) {
		int usedIndex = pageIndex;
		if (druckVorschau.isPageLayoutComplete()) {
			usedIndex = Math
					.min(pageIndex,
							druckVorschau.getPageCount()
									- (druckVorschau.getHorizontalPageCount() * druckVorschau
											.getVerticalPageCount()));
		}
		usedIndex = Math.max(usedIndex, 0);
		druckVorschau.setPageIndex(usedIndex);
		aktualisiereSeitenNummer();
	}

	private PagePrint erweiterePage(final PagePrint page, final String titel) {
		final IPreferenceStore preferenceStore = RahmenwerkActivator
				.getDefault().getPreferenceStore();
		// preferenceStore.getString(DefsSeiteneinstellungen.fusszeileLinks);

		// page.setHeader(new SeitenDekoration("A [Datum]", "B [Uhrzeit]", "C",
		// true));
		page.setHeader(new SeitenDekoration(
				preferenceStore
						.getString(DefsSeiteneinstellungen.ID_KOPFZEILE_LINKS),
				preferenceStore
						.getString(DefsSeiteneinstellungen.ID_KOPFZEILE_MITTE),
				preferenceStore
						.getString(DefsSeiteneinstellungen.ID_KOPFZEILE_RECHTS),
				true, titel));

		page.setHeaderGap(5);
		// page.setFooter(new SeitenDekoration("D", "E",
		// "F [Seite]/[Seitenanzahl]",
		// false));
		page.setFooter(new SeitenDekoration(
				preferenceStore
						.getString(DefsSeiteneinstellungen.ID_FUSSZEILE_LINKS),
				preferenceStore
						.getString(DefsSeiteneinstellungen.ID_FUSSZEILE_MITTE),
				preferenceStore
						.getString(DefsSeiteneinstellungen.ID_FUSSZEILE_RECHTS),
				false, titel));
		page.setFooterGap(5);

		return page;
	}

	/**
	 * Klasse zur Festlegung der Dekoration (Kopf- bzw. Fuzeile) einer Seite.
	 * 
	 * @author HofmannJ
	 * 
	 */
	private static class SeitenDekoration implements PageDecoration {
		/** Text im linken Bereich. */
		private final String links;

		/** Text im mittleren Bereich. */
		private final String mitte;

		/** Text im rechten Bereich. */
		private final String rechts;

		/**
		 * Kopf oder Fuzeile?
		 */
		private final boolean istKopfzeile;

		private LinkedList<String> sts;

		private final String titel;

		/**
		 * Konstruktor.
		 * 
		 * @param links
		 *            Text im linken Bereich.
		 * @param mitte
		 *            Text im mittleren Bereich.
		 * @param rechts
		 *            Text im rechten Bereich.
		 * @param istKopfzeile
		 *            Wenn <code>true</code>, dann handelt es sich um die
		 *            Kopfzeile und der Trennstrich wird nach allen anderen
		 *            Elementen gezeichnet. Bei <code>false</code> wird zuerst
		 *            der Trennstrich und dann alle anderen Elemente gezeichnet.
		 * @param titel
		 *            Text, mit dem das Feld <code>[Titel]</code> ersetzt wird.
		 */
		public SeitenDekoration(final String links, final String mitte,
				final String rechts, final boolean istKopfzeile,
				final String titel) {
			this.links = links;
			this.mitte = mitte;
			this.rechts = rechts;
			this.istKopfzeile = istKopfzeile;
			this.titel = titel;
		}

		@Override
		public Print createPrint(final PageNumber pageNumber) {
			final DefaultGridLook look = new DefaultGridLook();
			look.setCellSpacing(2, 2);

			final GridPrint grid = new GridPrint(
					"l:pref:none, c:pref:grow, r:pref:none", look);

			if (!istKopfzeile) {
				grid.add(new LinePrint(SWT.HORIZONTAL), GridPrint.REMAINDER);
			}

			sts = new LinkedList<String>();
			sts.add(links);
			sts.add(mitte);
			sts.add(rechts);
			pruefeStrings();

			/*
			 * Seitenzahlen setzen.
			 */
			for (final String text : sts) {
				if ((text.contains(Defs.FELD_SEITE))
						|| text.contains(Defs.FELD_SEITEN_ANZAHL)) {
					final PageNumberPageDecoration pnpd = new PageNumberPageDecoration();
					pnpd.setFormat(new PageNumberFormatErweitert(text));
					grid.add(pnpd.createPrint(pageNumber));

				} else {
					grid.add(new TextPrint(text));
				}
			}

			if (istKopfzeile) {
				grid.add(new LinePrint(SWT.HORIZONTAL), GridPrint.REMAINDER);
			}

			return grid;
		}

		/**
		 * Prft Strings und fhrt evtl. Ersetzungen durch Felddaten durch. *
		 */
		private void pruefeStrings() {
			final Date date = new Date();

			final DateFormat datumFormat = new SimpleDateFormat("dd.MM.yyyy");
			final String datum = datumFormat.format(date);

			final DateFormat zeitFormat = new SimpleDateFormat("HH:mm:ss");
			final String zeit = zeitFormat.format(date);

			final LinkedList<String> neueStrings = new LinkedList<String>();

			final Iterator<String> it = sts.iterator();
			while (it.hasNext()) {
				String pruefling = it.next();

				if (pruefling.contains(Defs.FELD_DATUM)) {
					pruefling = pruefling.replaceAll(Defs.REGEX_DATUM, datum);
				}

				if (pruefling.contains(Defs.FELD_UHRZEIT)) {
					pruefling = pruefling.replaceAll(Defs.REGEX_UHRZEIT, zeit);
				}

				if (pruefling.contains(Defs.FELD_TITEL)) {
					pruefling = pruefling.replaceAll(Defs.REGEX_TITEL, titel);
				}

				neueStrings.add(pruefling);
			}

			sts = neueStrings;
		}
	}
}
