/*
 * This file is part of Rahmenwerk 2.0.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Copyright (c) 2013 BitCtrl Systems GmbH.
 * 
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weissenfelser Strae 67
 * 04229 Leipzig
 * Phone: +49-341-49067-0
 * Fax:   +49-341-49067-15
 * mailto: support@bitctrl.de
 * 
 * Partly inspired by the original Rahmenwerk created by Dambach Werke GmbH.
 *   
 **************************************************************************************
 *
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 *
 * Copyright (c) 2008 Dambach Werke GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Dambach Werke GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */

package de.bsvrz.buv.rw.rw.printing;

import org.eclipse.nebula.paperclips.core.page.PageNumber;
import org.eclipse.nebula.paperclips.core.page.PageNumberFormat;

/**
 * Implementierung des Seitennummern-Formats aus dem PaperClips-Paket zur
 * Ausgabe der Gesamtseitenzahl und Seitennummer.
 * 
 * @author BitCtrl Systems GmbH, Uwe Peuker
 * @version $Id: PageNumberFormatErweitert.java 45420 2013-08-09 12:12:12Z peuker $
 */
public class PageNumberFormatErweitert implements PageNumberFormat {

	private String str = "";

	/**
	 * Konstruktor.
	 * 
	 * @param str
	 *            der Formatstring
	 */
	public PageNumberFormatErweitert(final String str) {
		this.str = str;
	}

	@Override
	public String format(final PageNumber pageNumber) {
		final int seite = pageNumber.getPageNumber() + 1;
		final int seitenAnzahl = pageNumber.getPageCount();

		String re = "Seite " + seite + " / " + seitenAnzahl;

		String neu = re;
		if ((str != null) && (str.length() > 0)) {
			neu = str;
		}

		if (neu.contains(Defs.FELD_SEITE)) {
			neu = neu.replaceAll(Defs.REGEX_SEITE, "" + seite);
		}

		if (neu.contains(Defs.FELD_SEITEN_ANZAHL)) {
			neu = neu.replaceAll(Defs.REGEX_SEITEN_ANZAHL, "" + seitenAnzahl);
		}

		re = neu;

		return re;
	}
}
